function [ F, gamma_y0 ] = Fmat(fhivec,y0,T,r)
idxt = 1:T;
gamma_y0 = spalloc(T,1,1);
F = sparse(T,T);
for i = 1:r
    fhir = fhivec((idxt-1)*r+i);
    F = F + spdiags(-fhir((i+1):end),-i,T,T);
    for j = i:r
        gamma_y0(i) = gamma_y0(i) + fhivec((i-1)*r+j)*y0(r+i-j);
    end
end
F = speye(T) + F;
end