function [ P  my ] = Pmy(fhimat,phimat,ypost,y0,T,r,s)

phi = [ones(T,1) -phimat];
fhi = -fhimat;
rhomatr = zeros(T,r);
rhomats = zeros(T,s);
my = sparse(T,1);

indexr = 1:r;
indexs = -(0:s);

index = indexs;
poly = phi;

for j = 1:r
    index = [index, indexr(j) + indexs];
    poly = [poly,repmat(fhi(:,j),1,s+1).*phi];
end

Frhob = sparse(T,T);
for j = 1:r
    rhomatr(:,j) = -sum(poly(:,index==j),2);
    Frhob = Frhob + spdiags(-rhomatr((j+1):end,j),-j,T,T);
end

for i = 1:r
    for j = i:r
        my(i) = my(i) + rhomatr(i,j)*y0(r+i-j);
    end
end

Frhof = sparse(T,T);
for j = 1:s
    rhomats(:,j) = -sum(poly(:,index==-j),2);
    Frhof = Frhof + spdiags(-rhomats(1:(end-j),j),-j,T,T);
end

for i = 1:s
    for j = i:s
        my(T-i+1) = my(T-i+1) + rhomats(T-i+1,j)*ypost(j-i+1);
    end
end

P = sparse(1:T,1:T,sum(poly(:,index==0),2)) + Frhob + Frhof';

end


