function [ c ] = polymult(a,b)

%  a,b: vectors of the polynomials to be multiplied

T = size(a,1);
p = size(a,2)-1;
q = size(b,2)-1;
r = p+q;
a = [a,zeros(T,r-p)];
b = [b,zeros(T,r-q)];
c = zeros(T,r+1);
for i = 1:r+1 c(:,i) = sum(a(:,1:i).*b(:,i:-1:1),2); end

end

