function [ P ] = polyrs(fhimat,phimat,T,r,s)

phi = [ones(T,1) -phimat];
fhi = -fhimat;

indexr = 1:r;
indexs = -(0:s);

index = indexs;
poly = phi;

for j = 1:r
    index = [index, indexr(j) + indexs];
    poly = [poly,repmat(fhi(:,j),1,s+1).*phi];
end

%P = sparse(1:T,1:T,sum(poly(:,index==0),2));

Frhob = sparse(T,T);
for j = 1:r
    Frhob = Frhob + spdiags(sum(poly((j+1):end,index==j),2),-j,T,T);
end

Frhof = sparse(T,T);
for j = 1:s
    Frhof = Frhof + spdiags(sum(poly(1:(end-j),index==-j),2),-j,T,T);
end

P = sparse(1:T,1:T,sum(poly(:,index==0),2)) + Frhob + Frhof';

end