function [ forecasts ] = forecastfunn(postphi,postfhi,eplus,horizon,ystar)

s = size(postphi,2);
r = size(postfhi,2);
T = length(ystar);

forecasts = zeros(1,horizon+r);
forecasts(1:r) = ystar((T-r+1):T);

for t = (r+1):(horizon+r)
    phi = postphi(t-r,:);
    fhi = postfhi(t-r,:);
    beta = zeros(1,T+s);
    beta(s) = 1;
    flag = 0; j = s; check = 1;
    while flag == 0
        j = j+1;
        beta(j) = sum(phi.*beta((j-1):-1:(j-s)));
        if j > 15
            check = mean(abs(beta(j:-1:(j-15))));
        end
        if check < 1e-10 || j == T+s
            flag = 1;
        end
    end
    beta = beta(s:(T+s));
    th = t - r;
    forecasts(t) = sum(fhi.*forecasts((t-1):-1:(t-r))) + sum(beta(1:end-th).*eplus(th:end)');
end

forecasts = forecasts((r+1):end);

end